config/routes.rb
# encoding: utf-8
#--
#   Copyright (C) 2012-2014 Gitorious AS
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

Gitorious::Application.routes.draw do
  ### R0. Site index
  root :to => "site#index"

  get "/gitlab-import" => "gitlab_import#new"

  ### R1. Repository browser (instance is configured in an initializer)
  match "/:project_id/:repository_id/:action/*slug" => Gitorious::RepositoryBrowser.instance, :action => /(source|tree_history|raw|blame|history|archive)/, :as => :repository_browser
  match "/:project_id/:repository_id/refs" => Gitorious::RepositoryBrowser.instance, :as => :repository_refs

  ### R2. User routes
  resources :users, :only => [:new, :create] do
    collection do
      get "/forgot_password" => "password_resets#new", :as => :forgot_password
      post "/forgot_password" => "password_resets#generate_token", :as => :forgot_password_create
      get "/reset_password/:token" => "password_resets#prepare_reset", :as => :reset_password
      put "/reset_password/:token" => "password_resets#reset", :as => :do_reset_password
      get "/activate/:activation_code" => "user_activations#create"
      get "/pending_activation" => "user_activations#show", :as => :pending_activation
      get "/openid_build" => "open_id_users#new"
      post "/openid_create" => "open_id_users#create"
      get "/new" => "users#new"
      get "/view_state/repository/:id.:format" => "repository_view_state#show", :as => :repository_view_state
      get "/view_state/project/:id.:format" => "project_view_state#show", :as => :project_view_state
      get "/view_state.:format" => "user_view_state#show", :as => :view_state

      # Used to be we supported things like /users/~zmalltalker/mainline
      # No more, ~<user_name> is the canonical user URL namespace
      get "/*slug" => (redirect do |params, request|
                         request.fullpath.sub("users/", "~")
                       end), :slug => /.*/
    end
  end

  # `resources :users` can't do the ~<user> ids
  get "/~:id.keys" => "public_keys#index", :id => /[^\/]+/
  get "/~:id(.:format)" => "users#show", :as => "user", :id => /[^\/]+/
  get "/~:id/edit(.:format)" => "users#edit", :as => "edit_user", :id => /[^\/]+/
  put "/~:id(.:format)" => "users#update", :id => /[^\/]+/
  delete "/~:id(.:format)" => "users#destroy", :id => /[^\/]+/

  # Additional user actions
  scope "/~:id", :id => /[^\/]+/, :as => :user do
    get "/delete_current" => "users#destroy", :as => :delete_current
    delete "/avatar" => "avatars#destroy"
    get "/watchlist" => "user_watchlists#show", :as => :watchlist
    get "/feed" => "user_feeds#show", :as => :feed
    put "/update_password" => "passwords#update", :as => :update_password

    get "/aliases" => "users#edit", :defaults => { :tab => "email-aliases" }, :as => :edit_email_aliases
    get "/ssh-keys" => "users#edit", :defaults => { :tab => "ssh-keys" }, :as => :edit_ssh_keys
    get "/password" => "users#edit", :defaults => { :tab => "change-password" }, :as => :edit_password
    get "/favorites" => "users#edit", :defaults => { :tab => "manage-favorites" }, :as => :edit_favorites
  end

  # Nested user resources. This is in a separate scope because the
  # controllers expect params[:user_id] to contain the user, not
  # params[:id] as in the scope above
  scope "/~:user_id", :user_id => /[^\/]+/, :as => :user do
    resources :keys, :only => [:new, :create, :destroy, :index]

    resources :aliases do
      member do
        get :confirm
      end
    end

    get "/repositories" => "repositories#index"
    resource :license, :only => [:show, :edit, :update]
    match "/*slug" => "owner_redirections#show"
  end

  ### R3. Sessions
  resource :sessions
  get "/sessions" => "sessions#create", :as => :open_id_complete
  get "/login" => "sessions#new", :as => :login
  get "/login/http" => "sessions#http" # for Kerberos authentication
  get "/logout" => "sessions#destroy", :as => :logout

  ### R4. Groups
  resources :groups, :only => [:index, :new, :create]
  # `resource :groups` can't do the +<group> ids
  get "/+:id(.:format)" => "groups#show", :as => "group", :id => /[^\/]+/
  get "/+:id/edit(.:format)" => "groups#edit", :as => "edit_group", :id => /[^\/]+/
  put "/+:id(.:format)" => "groups#update", :id => /[^\/]+/
  delete "/+:id(.:format)" => "groups#destroy", :id => /[^\/]+/

  # Additional group actions
  scope "/+:id", :id => /[^\/]+/, :as => :group do
    delete "avatar" => "groups#avatar"
  end

  # Nested group resources. This is in a separate scope because the
  # controllers expect params[:group_id] to contain the group, not
  # params[:id] as in the scope above
  scope "/+:group_id", :id => /[^\/]+/, :as => :group do
    resources :memberships
    get "/repositories" => "repositories#index"
    match "/*slug" => "owner_redirections#show"
  end

  ### R5. Site-wide wiki
  get "/wiki/:site_id/config" => "site_wiki_pages#repository_config", :as => :site_wiki_git_access_connect
  get "/wiki/:site_id/writable_by" => "site_wiki_pages#writable_by", :as => :site_wiki_git_writable_by

  resources :site_wiki_pages, :path => "/wiki" do
    collection do
      get :git_access
    end

    member do
      get :history
    end
  end

  ### R6. Direct merge request access
  match "/merge_request_landing_page" => "merge_requests#oauth_return", :as => :merge_request_landing_page
  get "/merge_requests/:id" => "merge_requests#direct_access", :as => :merge_request_direct_access

  ### R7. Site controller, various loose pages
  get "/activities" => "site#public_timeline", :as => :activity
  get "/dashboard" => "site#dashboard", :as => :dashboard
  get "/my-activities" => "site#my_activities", :as => :dashboard_my_activities
  get "/about" => "site#about", :as => :about
  get "/about/:action" => "site#index", :as => :about_page
  get "/contact" => "site#contact", :as => :contact

  ### R8. Administration
  namespace :admin do
    get "/" => redirect { |params, request| "/admin/repositories" }

    resources :users, :only => [:index, :new, :create] do
      member do
        put :suspend
        put :flip_admin_status
        put :unsuspend
        put :reset_password
      end

      resources :keys, only: [:index, :new, :create, :destroy]
    end

    resources :projects, :only => [:show] do
      resource :oauth_settings, :only => [:show, :edit, :update]
    end

    resources :repositories, :only => [:index] do
      member do
        put :recreate
      end
    end

    resources :project_proposals, :only => [:index, :new, :create]
    post "/project_proposals/:id/reject" => "project_proposals#reject"
    post "/project_proposals/:id/approve" => "project_proposals#approve"
  end

  ### R9. API
  namespace :api do
    get ":project_id/:repository_id/log/graph(.:format)" => "graphs#show"
    get ":project_id/:repository_id/log/graph/*branch(.:format)" => "graphs#show"

    namespace :internal do
      get "/repo-config", to: "repository_configurations#show"
      get "/authenticate", to: "users#authenticate"
      get "/hooks/pre-receive", to: "hooks#pre_receive"
      post "/hooks/post-receive", to: "hooks#post_receive"
    end
  end

  ### R10. Events
  resources :events do
    member do
      get :commits
    end
  end

  ### R11. Additional logged in user resources
  resources :messages do
    collection do
      get :sent
      put :bulk_update
      get :all
      get :auto_complete_for_message_recipients
    end

    member do
      post :reply
      put :read
    end
  end

  resources :favorites, :only => [:index, :create, :update, :destroy]

  ### R12. Search
  get "/search", :controller => "searches", :action => "show", :as => :search

  ### R13. Auto-completion
  resources :user_auto_completions, :only => [:index]
  resources :group_auto_completions, :only => [:index]

  ### R14. Projects
  resources :projects, :only => [:index, :create]
  get "/:id/edit(.:format)" => "projects#edit"

  resources :projects, :path => "/" do
    member do
      put :preview
      get :edit_slug
      put :edit_slug
      get :confirm_delete
      get "/ownership/edit" => "project_ownerships#edit", :as => :transfer_ownership
      put "/ownership/edit" => "project_ownerships#update", :as => :transfer_ownership
    end

    resources :project_memberships, :only => [:index, :new, :create, :destroy]
    get "/community", :controller => :project_community, :action => :index
    get "/merge_requests", :controller => :project_merge_requests, :action => :index

    resources :pages do
      collection do
        get :git_access
      end

      member do
        get :history
      end
    end

    ### R14.2. Repositories

    # Listing repositories and creating new ones happens over
    # /<project>/repositories/, e.g:
    #   /gitorious/repositories/new
    resources :repositories, :only => [:index, :new, :create]

    # Browsing, editing and destroying existing repositories happens over
    # /<project>/<repository_name>/, e.g.:
    #   /gitorious/mainline
    #   /gitorious/mainline/edit
    resources(:repositories, {
                :path => "/",
                :only => [:show, :edit, :update, :destroy]
              }) do
      member do
        post "/create_clone" => "repository_clones#create"
        get "/clone" => "repository_clones#new"
        get "/search_clones" => "repository_clone_searches#show"

app/controllers/admin/repositories_controller.rb
# encoding: utf-8
#--
#   Copyright (C) 2012 Gitorious AS
#   Copyright (C) 2010 Marius Mathiesen <marius@shortcut.no>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

module Admin
  class RepositoriesController < AdminController
    def index
      begin
        repositories, total_pages, page = paginated_repositories
      rescue RangeError => err
        flash[:error] = "Page #{page} does not exist"
        redirect_to(admin_repositories_path, :status => 307) and return
      end

      render("index", :locals => {
          :repositories => repositories,
          :total_pages => total_pages,
          :page => page
        })
    end

    def recreate
      repository = Repository.find(params[:id])
      CreateProjectRepositoryCommand.new(Gitorious::App).schedule_creation(repository)
      flash[:notice] = "Recreation message posted"
      redirect_to(:action => :index)
    end

    private
    def paginated_repositories
      scope = Repository.where("ready = false AND kind != #{Repository::KIND_TRACKING_REPO}")
      page = (params[:page] || 1).to_i
      repositories, pages = JustPaginate.paginate(page, Repository.per_page, scope.count) do |range|
        scope.offset(range.first).limit(range.count).includes(:project)
      end
      [repositories, pages, page]
    end
  end
end

app/helpers/repositories_helper.rb
# encoding: utf-8
#--
#   Copyright (C) 2012, 2014 Gitorious AS
#   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
#   Copyright (C) 2007, 2008 Johan Sørensen <johan@johansorensen.com>
#   Copyright (C) 2008 David A. Cuadrado <krawek@gmail.com>
#   Copyright (C) 2008 Tor Arne Vestbø <tavestbo@trolltech.com>
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#++

module RepositoriesHelper
  include FavoritesHelper

  def markdown_help
    <<-HTML
          <div class="collapse gts-help" id="markdown-help">
            <table class="table">
              <tr>
                <td><pre><code>[link](http://gitorious.org)</code></pre></td>
                <td><a href="http://gitorious.org">link</a></td>
              </tr>
              <tr>
                <td><pre><code>    if (true) {
        return;
    }</code></pre></td>
                <td><pre><code>if (true) {
    return;
}</code></pre></td>
              </tr>
              <tr>
                <td><pre><code>inline `code` here</code></pre></td>
                <td>      inline <code>code</code> here</td>
              </tr>
              <tr>
                <td><pre><code>**bold**</code></pre></td>
                <td><strong>bold</strong></td>
              </tr>
              <tr>
                <td><pre><code>_emphasized_</code></pre></td>
                <td><em>emphasized</em></td>
              </tr>
              <tr>
                <td><pre><code>* item 1
* item 2</code></pre></td>
                <td><ul><li>item 1</li><li>item 2</li></ul></td>
              </tr>
              <tr>
                <td><pre><code>1. item 1
2. item 2</code></pre></td>
                <td><ol><li>item 1</li><li>item 2</li></ol></td>
              </tr>
              <tr>
                <td><pre><code># Header 1#</code></pre></td>
                <td><h1>Header 1</h1></td>
              </tr>
              <tr>
                <td><pre><code>## Header 2</code></pre></td>
                <td><h2>Header 2</h2></td>
              </tr>
            </table>
            <p><a href="http://daringfireball.net/projects/markdown/">Full Markdown reference</a></p>
          </div>
    HTML
  end
end

app/views/repositories/_getting_started.html.erb
<%
  #--
  #   Copyright (C) 2013-2014 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>

<%= repo_header repository, :current_user => current_user %>

<div class="container">
  <div class="row">
    <div class="alert alert-info span7">
      <h2>Congratulations on your new repository!</h2>
      <p>
        Please follow these few steps to start using your new repository.
      </p>
      <h3>Install and configure Git</h3>
      <p>
        If you haven't already,
        <a href="http://git-scm.com">download and install Git</a>. Then provide some basic configuration to Git:
      </p>
      <pre class="prettyprint">git config --global user.name "<%=h current_user && current_user.fullname || "Your full name" -%>"
git config --global user.email "<%=h current_user && current_user.email || "your@email.com" -%>"</pre>
      <h3>Create a new Git repository</h3>
      <p>
        If your project is not already using Git, initialize a
        repository now:
      </p>
      <pre class="prettyprint">git init .</pre>
      <p>
        Add the existing files to Git's index and commit:
      </p>
      <pre class="prettyprint">git add .
git commit -m "Initial commit"</pre>
      <h3>Push your changes</h3>
      <p>
        Configure your newly created Gitorious repository as a
        "remote", then push your changes:
      </p>
      <pre class="prettyprint">git remote add origin <%= Gitorious.default_remote_url(repository) %>
git push -u origin master</pre>
      <p>
        The <code>-u</code> (<code>--set-upstream</code>) tells Git that your
        <code>master</code> branch always goes to the <code>origin</code> remote.
        Next time you can push by simply issuing:
      </p>
      <pre class="prettyprint">git push</pre>
    </div>
  </div>
</div>

app/views/repositories/_non_existent_refspec.html.erb
<%
  #--
  #   Copyright (C) 2013 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>
<% @title = error.message -%>
<% if !repository.ready? %>
  <%= render(:partial => "repositories/pending", :locals => { :repository => repository }) %>
<% elsif !repository.has_commits? && committers(repository).include?(current_user) %>
  <%= render(:partial => "repositories/getting_started", :locals => { :repository => repository }) %>
<% else %>
  <%= repo_header repository, :current_user => current_user, :ref => ref, :active => :source, :header_level => 2 %>
  <div class="container gts-body">
    <h2><%= error.message %></h2>
    <p><a href="<%= tree_entry_url(repository.slug, ref) %>">Repository root</a></p>
  </div>
<% end %>

app/views/repositories/_pending.html.erb
<%
  #--
  #   Copyright (C) 2013 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>
<div class="gts-site-header gts-new-repo" data-gts-env-repository-view-state-path="/users/view_state/repository/<%= repository.id %>.json">
  <div class="container">
    <div class="row">
      <h1 class="span">
        <a href="<%= project_path(repository.project) %>"><%= repository.project.slug %></a> /
        <span><%= repository.name %></span>
      </h1>
    </div>
    <div class="gts-repository-admin-ph gts-placeholder"></div>
    <%= description(repository.project) %>
    <div class="row">
      <div class="alert alert-info span6">
        <h2>Your new repository is being created</h2>
        <p>
          This page will be reloaded when your repository is created.
          If the page doesn't reload after a few seconds,
          try <a href="">reloading it</a>.
        </p>
        <p>
          If this message persists for more than a few minutes,
          contact
          <a href="mailto:<%= Gitorious.support_email %>"><%= Gitorious.support_email %></a>.
        </p>
      </div>
    </div>
  </div>
</div>

app/views/repositories/_repositories.html.erb
<%
  #--
  #   Copyright (C) 2013 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% if !repositories.blank? || defined?(hint) %>
  <%= pull_box(heading, :class => 'repositories-box') do %>
    <% if repositories.blank? %>
      <p class="hint muted"><%= hint %></p>
    <% else %>
      <table class="table">
        <% repositories.each do |repo| %>
          <tr>
            <td class="repository">
              <%= link_to h(repo.url_path), [repo.project, repo] %>
            </td>
          </tr>
        <% end %>
      </table>
      <%= footer.html_safe if defined?(footer) %>
    <% end %>
  <% end %>
<% end %>

app/views/repositories/_repository.html.erb
<%
  #--
  #   Copyright (C) 2012 Gitorious AS
  #   Copyright (C) 2009 Fabio Akita <fabio.akita@gmail.com>
  #   Copyright (C) 2008 Tor Arne Vestbø <tavestbo@trolltech.com>
  #   Copyright (C) 2007 Johan Sørensen <johan@johansorensen.com>
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>

<h3><%= link_to h(repository.url_path), project_repository_path(repository.project, repository) -%></h3>
<p><%= truncate h(repository.description), :length => 250 -%></p>

app/views/repositories/_repository_sidebar.html.erb
<%
  #--
  #   Copyright (C) 2012-2014 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<li class="clone">
  <% if repository.owned_by_group? %>
    <span class="group">
      <%= group_avatar(repository.owner, :size => :icon) %>
      <%= link_to h(repository.owner_to_param_with_prefix), repository.owner %>
    </span>
  <% else %>
    <span class="user">
      <%= avatar(repository.user, :size => 16) %>
      <%= link_to h(repository.user_to_param_with_prefix), repository.user %>
    </span>
  <% end %>
  &raquo;
  <span class="name">
    <%= link_to h(repository.name), [repository.project, repository] %>
  </span>
</li>

app/views/repositories/edit.html.erb
<%
  #--
  #   Copyright (C) 2012-2013 Gitorious AS
  #   Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies)
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
  %>
<%= repo_header repository, :current_user => current_user, :active => :admin, :header_level => 2 %>

<div class="container" id="gts-pjax-container">
  <%= error_messages(repo_edit) -%>
  <%= form_for(repo_edit, :as => :repository, :url => project_repository_url(repository.project, repository), :method => "put", :html => { :class => "form-horizontal" }) do |f| -%>
    <fieldset>
      <legend><%= @title = "Editing repository #{repository.slug}" %></legend>
      <%= live_md_preview_textarea(f, :description, "Description") %>
      <div class="control-group">
        <%= f.label :name, :class => "control-label" -%>
        <div class="controls">
          <%= f.text_field :name, :class => "input-xlarge" -%>
          <p class="help-block">
            NB! Changing the name will also immediately change all URLs (including Git clone URLs).
          </p>
        </div>
      </div>
      <div class="control-group">
        <%= f.label :head, :class => "control-label" -%>
        <div class="controls">
          <%= f.select(:head, heads.map{|h| [h.name, h.name] },
                :selected => repository.head ? repository.head.name : nil) -%>
          <p class="help-block">
            Changes the symbolic ref the HEAD in the git repository points to, i.e.
            the default branch to show.
          </p>
        </div>
      </div>
      <div class="control-group">
        <label for="force-pushing" class="control-label">Force-pushing</label>
        <div class="controls">
          <label class="checkbox">
            <input type="checkbox" value="1" name="force_pushing" id="force-pushing"<%= " checked" if !repository.deny_force_pushing %>>
            Enable
          </label>
          <p class="help-block">
            Allows pushing "non-fastforwards" (e.g. git push -f). Enabling
            force-pushing also allows tag<br>creation and remote branch removals.
          </p>
        </div>
      </div>
      <div class="control-group">
        <label for="merge-requests" class="control-label">Merge requests</label>
        <div class="controls">
          <label class="checkbox">
            <%= f.check_box :merge_requests_enabled, :id => "merge-requests" %>
            Enable
          </label>
          <p class="help-block">
            Allow Gitorious users to request merging of contributions from
            repository clones.
          </p>
        </div>
      </div>
      <div class="form-actions">
        <button class="btn btn-primary" type="submit">Save changes</button>
        <span class="cancel"><%= link_to 'Cancel', project_repository_path(repository.project, repository) %></span>
      </div>
    </fieldset>
  <% end %>
</div>

app/views/repositories/go-get.html.erb
<html>
  <head>
    <% if Gitorious.git_http %>
      <meta name="go-import" content="<%= Gitorious.host %>/<%= repository.url_path %> git <%= repository.http_clone_url %>" />
    <% end %>
  </head>
  <body></body>
</html>

app/views/repositories/new.html.erb
<%
  #--
  #   Copyright (C) 2013 Gitorious AS
  #
  #   This program is free software: you can redistribute it and/or modify
  #   it under the terms of the GNU Affero General Public License as published by
  #   the Free Software Foundation, either version 3 of the License, or
  #   (at your option) any later version.
  #
  #   This program is distributed in the hope that it will be useful,
  #   but WITHOUT ANY WARRANTY; without even the implied warranty of
  #   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  #   GNU Affero General Public License for more details.
  #
  #   You should have received a copy of the GNU Affero General Public License
  #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
  #++
%>

<% @page_title = "Add new repository to #{h(project.title)}" %>

<%= render "projects/header", :project => project, :active => :admin  %>

<div class="container" id="gts-pjax-container">
  <%= error_messages(repository) -%>
  <%= form_for(repository, :as => :repository, :url => project_repositories_url(repository.project), :html => { :class => "form-horizontal" }) do |f| -%>
    <fieldset>
      <legend>Create a new repository</legend>
      <p class="well">
        The new <%= link_to(h(project.title), project) %> repository will be
        owned by <%= link_to h(repository.owner.title), repository.owner -%>
        (a <%= repository.owner.class.human_name.downcase -%>).
      </p>
      <div class="control-group">
        <%= f.label :name, "Name", :class => "control-label" -%>
        <div class="controls">
          <%= f.text_field :name, :class => "input-xlarge" -%>
        </div>
      </div>
      <%= live_md_preview_textarea(f, :description, "Description") %>
      <% if Gitorious.private_repositories? %>
        <div class="control-group">
          <label for="private" class="control-label">Private repository?</label>
          <div class="controls">
            <label class="checkbox">
              <input type="checkbox" value="1" name="private" id="private"<%= " checked" if params[:private] %>>
            </label>
            <p class="help-block">
              Private repositories can only be accessed by you and
              individuals/groups you grant access to.
            </p>
          </div>
        </div>
      <% end %>
      <div class="form-actions">
        <button class="btn btn-primary" type="submit">Create repository</button>
        <span class="cancel"><%= link_to 'Cancel', project_path(project) %></span>
      </div>
    </fieldset>
  <% end %>
</div>